//Clipping.cpp

#include <assert.h>
#include <d3d9.h>
#include <d3dx9.h>
#include "DxPolygon.h"
#include "Clipping.h"




void ComputeNormal( D3DXVECTOR3* out, D3DXVECTOR3* p0, D3DXVECTOR3* p1, D3DXVECTOR3* p2 )
{
	D3DXVECTOR3 u = *p1 - *p0;  
	D3DXVECTOR3 v = *p2 - *p0;

  	D3DXVec3Cross(out, &u, &v);
  	D3DXVec3Normalize(out, out);

/*
	D3DXVECTOR3 out;
	D3DXVECTOR3 p0 = D3DXVECTOR3( -1, -1, 0 );
	D3DXVECTOR3 p1 = D3DXVECTOR3( -1,  1, 0 );
	D3DXVECTOR3 p2 = D3DXVECTOR3(  1,  0, 0 );

	ComputeNormal( &out, &p0, &p1, &p2 ); //0, 0, -1 --> ޼ ǥ迡 ð Ѵ.
	ComputeNormal( &out, &p0, &p2, &p1 ); //0, 0, 1 -->  ǥ迡 ݽð Ѵ.
*/
}
//  ̿
//pd clipϰϴ ǥ 
bool IsRightAxis( int axis, const D3DXVECTOR3& v0, const D3DXVECTOR3& v1, const D3DXVECTOR3& v2 )
{
	D3DXVECTOR3 p0 = v0;	
	D3DXVECTOR3 p1 = v1;
	D3DXVECTOR3 p2 = v2;
	p0[axis] = 0;
	p1[axis] = 0;
	p2[axis] = 0;

	D3DXVECTOR3 u = p1 - p0;  
	D3DXVECTOR3 v = p2 - p0;

	D3DXVECTOR3 out;
  	D3DXVec3Cross( &out, &u, &v);
  	D3DXVec3Normalize( &out, &out);

	if( out[axis] > 0 )
		return true;
	else
		return false;
}

// ̰    Ѵ.( x = 0, y = 1, z = 2 )
int GetMinAxis( const D3DXVECTOR3& v0, const D3DXVECTOR3& v1, const D3DXVECTOR3& v2 )
{
	D3DXVECTOR3 dmin = v0;
	if( v1.x < dmin.x )		dmin.x = v1.x;
	if( v1.y < dmin.y )		dmin.y = v1.y;
	if( v1.z < dmin.z )		dmin.z = v1.z;
	if( v2.x < dmin.x )		dmin.x = v2.x;
	if( v2.y < dmin.y )		dmin.y = v2.y;
	if( v2.z < dmin.z )		dmin.z = v2.z;

	D3DXVECTOR3 dmax = v0;
	if( v1.x > dmax.x )		dmax.x = v1.x;
	if( v1.y > dmax.y )		dmax.y = v1.y;
	if( v1.z > dmax.z )		dmax.z = v1.z;
	if( v2.x > dmax.x )		dmax.x = v2.x;
	if( v2.y > dmax.y )		dmax.y = v2.y;
	if( v2.z > dmax.z )		dmax.z = v2.z;

	float dx = (float)fabs( (double)dmax.x - dmin.x );
	float dy = (float)fabs( (double)dmax.y - dmin.y );
	float dz = (float)fabs( (double)dmax.z - dmin.z );

	int axis = 0;

	if ( dy < dx )
	{
		axis = 1;
	}

	if ( dz < dx && dz < dy )
	{
		axis = 2;
	}

	return axis;
}

void ComputePolygonNormal( DxPolygon* polygon )
{
#if  1
	PointArray& vrtArr = polygon->GetPosition();
	int nSize = (int)vrtArr.size();
	assert( nSize >= 3 );

	D3DXVECTOR3 out;
	for( int i = 0; i < nSize; i += 3 )
	{
		D3DXVECTOR3 v0( vrtArr[i].x, vrtArr[i].y, vrtArr[i].z );
		D3DXVECTOR3 v1( vrtArr[i+1].x, vrtArr[i+1].y, vrtArr[i+1].z );
		D3DXVECTOR3 v2( vrtArr[i+2].x, vrtArr[i+2].y, vrtArr[i+2].z );
		ComputeNormal( &out, &v0, &v1, &v2 );
		polygon->PushBackNormal( DataType::Point3( out.x, out.y, out.z )  );
		polygon->PushBackNormal( DataType::Point3( out.x, out.y, out.z )  );
		polygon->PushBackNormal( DataType::Point3( out.x, out.y, out.z )  );
	}
#else
	typedef std::vector<int> IndexArrayComponent;

	PointArray& vrtArr = polygon->GetPosition();
	int nSize = (int)vrtArr.size();
	if( nSize < 3 )
		return;

	//assert( nSize >= 3 );
	D3DXVECTOR3* normal = new D3DXVECTOR3[ nSize ];
	memset( normal, 0, nSize * sizeof( D3DXVECTOR3 ) );

	IndexArrayComponent* sharedNormalIndex = new IndexArrayComponent[ nSize ];
	for( int i = 0; i < nSize; ++i )
	{
		for( int k = 0; k < nSize; ++k )
		{
			if( i != k )
			{
				if( vrtArr[i].x == vrtArr[k].x && vrtArr[i].y == vrtArr[k].y && vrtArr[i].z == vrtArr[k].z )
				{
					sharedNormalIndex[i].push_back( k );
				}
			}
		}	
	}

	D3DXVECTOR3 out;
	for( int i = 0; i < nSize; i += 3 )
	{
		D3DXVECTOR3 v0( vrtArr[i].x, vrtArr[i].y, vrtArr[i].z );
		D3DXVECTOR3 v1( vrtArr[i+1].x, vrtArr[i+1].y, vrtArr[i+1].z );
		D3DXVECTOR3 v2( vrtArr[i+2].x, vrtArr[i+2].y, vrtArr[i+2].z );
		ComputeNormal( &out, &v0, &v1, &v2 );

		normal[i+0] += out;
		normal[i+1] += out;
		normal[i+2] += out;

		int nCount = (int)sharedNormalIndex[i].size();
		IndexArrayComponent& indexArr0 = sharedNormalIndex[i];
		for( int k = 0; k < nCount; ++k )
		{
			int index = indexArr0[k];
			normal[ index ] += out;
		}

		nCount = (int)sharedNormalIndex[i+1].size();
		IndexArrayComponent& indexArr1 = sharedNormalIndex[i+1];
		for( int k = 0; k < nCount; ++k )
		{
			int index = indexArr1[k];
			normal[ index ] += out;
		}

		nCount = (int)sharedNormalIndex[i+2].size();
		IndexArrayComponent& indexArr2 = sharedNormalIndex[i+2];
		for( int k = 0; k < nCount; ++k )
		{
			int index = indexArr2[k];
			normal[ index ] += out;
		}
	}

	for( int i = 0; i < nSize; ++i )
	{
		D3DXVec3Normalize(&normal[i], &normal[i]);
		polygon->PushBackNormal( DataType::Point3( normal[i].x, normal[i].y, normal[i].z )  );
	}

	delete [] normal;
	delete [] sharedNormalIndex;
#endif
}

inline float LinearEquation( float x, float x1, float x2, float y1, float y2 )
{
	float y = ( x - x1 ) * ( y2 - y1 ) / ( x2 - x1 ) + y1;
	return y;
}

int ClipPolyLine1( const D3DXVECTOR3* in, int n, float* out, float nx, float ny, float nz, float pd )
{
	float d[12];

	float basis = (nx + ny + nz) * pd;
	for (int i = 0; i < n; ++i)
		d[i] = nx*in[i].x + ny*in[i].y + nz*in[i].z - basis;

	int m = 0;
	float x = pd;
	//ο ؼ ˻
	for (int i = 0, j = n-1; i < n; j=i, ++i)
	{
		bool ina = d[j] >= 0;
		bool inb = d[i] >= 0;
		if (ina != inb)
		{
			if( nx != 0 )
			{
				out[m*3+0] = pd;	
				out[m*3+1] = LinearEquation( pd, in[j].x, in[i].x, in[j].y, in[i].y );
				out[m*3+2] = LinearEquation( pd, in[j].x, in[i].x, in[j].z, in[i].z );
			} 
			else if( ny != 0 )
			{
				out[m*3+1] = pd;
				out[m*3+0] = LinearEquation( pd, in[j].y, in[i].y, in[j].x, in[i].x );
				out[m*3+2] = LinearEquation( pd, in[j].y, in[i].y, in[j].z, in[i].z );		
			} 
			else
			{
				out[m*3+2] = pd;
				out[m*3+0] = LinearEquation( pd, in[j].z, in[i].z, in[j].x, in[i].x );
				out[m*3+1] = LinearEquation( pd, in[j].z, in[i].z, in[j].y, in[i].y );				
			}
			m++;
		}
		if (inb)
		{
			out[m*3+0] = in[i].x;
			out[m*3+1] = in[i].y;
			out[m*3+2] = in[i].z;
			m++;
		}
	}

	return m;
}

int ClipPolySimple( const D3DXVECTOR3* in, int n, float* out, float nx, float ny, float nz, float pd )
{
	float d[12];

	float sign = nx + ny + nz;
	nx *= nx;   ny *= ny;   nz *= nz;
	
	for (int i = 0; i < n; ++i)
		d[i] = nx*in[i].x + ny*in[i].y + nz*in[i].z - pd;

	int m = 0;
	//ο ؼ ˻
	for (int i = 0, j = n-1; i < n; j=i, ++i)
	{
		bool ina = d[j] >= 0;
		bool inb = d[i] >= 0;
		if (ina != inb)
		{
			if( nx != 0 )
			{
				out[m*3+0] = pd;	
				out[m*3+1] = LinearEquation( pd, in[j].x, in[i].x, in[j].y, in[i].y );
				out[m*3+2] = LinearEquation( pd, in[j].x, in[i].x, in[j].z, in[i].z );
			} 
			else if( ny != 0 )
			{
				out[m*3+1] = pd;
				out[m*3+0] = LinearEquation( pd, in[j].y, in[i].y, in[j].x, in[i].x );
				out[m*3+2] = LinearEquation( pd, in[j].y, in[i].y, in[j].z, in[i].z );		
			} 
			else
			{
				out[m*3+2] = pd;
				out[m*3+0] = LinearEquation( pd, in[j].z, in[i].z, in[j].x, in[i].x );
				out[m*3+1] = LinearEquation( pd, in[j].z, in[i].z, in[j].y, in[i].y );				
			}
			m++;
		}
		if (d[i] * sign >= 0)
		{
			out[m*3+0] = in[i].x;
			out[m*3+1] = in[i].y;
			out[m*3+2] = in[i].z;
			m++;
		}
	}
	return m;
}

//  ̿
//nx, ny, nz ߿ ϳ Ѵ. õ  (-)̸  ߸ ̸  ߷ .
//pd clipϰϴ ǥ 
int ClipPolyLine(const D3DXVECTOR3* in, int n, float* out, float nx, float ny, float nz, float pd)
{
	float d[12];

	if( nx + ny + nz > 0 )
		pd = -pd;
	for (int i = 0; i < n; ++i)
		d[i] = nx*in[i].x + ny*in[i].y + nz*in[i].z + pd;
	
	int m = 0;
	//ο ؼ ˻
	for (int i = 0, j = n-1; i < n; j=i, ++i)
	{
		bool ina = d[j] >= 0;
		bool inb = d[i] >= 0;
		if (ina != inb)
		{
			float s = d[j] / (d[j] - d[i]);   //̿   ü ̿  d[j] 
			                                                   
			out[m*3+0] = in[j].x + (in[i].x - in[j].x)*s;   // b - ( b - a ) * s  pd  ϴ ǥ̴.
			out[m*3+1] = in[j].y + (in[i].y - in[j].y)*s;
			out[m*3+2] = in[j].z + (in[i].z - in[j].z)*s;
			m++;
		}
		if (inb)
		{
			out[m*3+0] = in[i].x;
			out[m*3+1] = in[i].y;
			out[m*3+2] = in[i].z;
			m++;
		}
	}
	return m;
}

int ClipTriangle( const D3DXVECTOR3* in, float* out, float nx, float ny, float nz, float pd )
{
#if  0
	return ClipPolyLine( in, 3, out, nx, ny, nz, pd );
#else
	return ClipPolyLine1( in, 3, out, nx, ny, nz, pd );
#endif
}



const float  FLOAT_EPSILON = 1e-06f;
#define D3DX_HALF_PI  (  D3DX_PI * 0.5f )
#define MAT( i, j )    ( m->operator()( i, j ) )



inline float aFloor( float fValue )
{
	if( fabs( fValue ) < FLOAT_EPSILON )
		fValue = 0;
	return fValue;
}


inline float aSin (float fValue) 
{
    if ( -1.0f < fValue ) 
	{
        if ( fValue < 1.0f ) 
		{
            return aFloor( float(::asin(fValue)) );
        }
		else 
		{
            return -D3DX_PI * 0.5f;
        }
    } 
	else 
	{
        return D3DX_PI * 0.5f;
    }
}

inline float aTan2 (float fY, float fX) 
{
	return aFloor( float(::atan2(fY, fX)) );
}


//http://arcemu.info/doxygen/_matrix3_8cpp_source.html
//http://www.irit.fr/~Loic.Barthe/Enseignements/BE_Modelisation/Robo/Doc/Matrix3_8cpp-source.html
#if  0
bool Matrix3::toEulerAnglesYXZ (float& rfYAngle, float& rfXAngle,
                                float& rfZAngle) const {
    // rot =  cy*cz+sx*sy*sz  cz*sx*sy-cy*sz  cx*sy
    //        cx*sz           cx*cz          -sx
    //       -cz*sy+cy*sx*sz  cy*cz*sx+sy*sz  cx*cy

    if ( elt[1][2] < 1.0 ) {
        if ( elt[1][2] > -1.0 ) {
            rfYAngle = G3D::aTan2(elt[0][2], elt[2][2]);
            rfXAngle = (float) asin( -elt[1][2]);
            rfZAngle = G3D::aTan2(elt[1][0], elt[1][1]);
            return true;
        } else {
            // WARNING.  Not unique.  YA - ZA = atan2(r01,r00)
            rfYAngle = G3D::aTan2(elt[0][1], elt[0][0]);
            rfXAngle = (float)G3D_HALF_PI;
            rfZAngle = 0.0;
            return false;
        }
    } else {
        // WARNING.  Not unique.  YA + ZA = atan2(-r01,r00)
        rfYAngle = G3D::aTan2( -elt[0][1], elt[0][0]);
        rfXAngle = -(float)G3D_HALF_PI;
        rfZAngle = 0.0f;
        return false;
    }
}
#else
bool ToEulerAnglesYXZ( D3DXVECTOR3* out, const D3DXMATRIX* m ) 
{
    // rot =  cy*cz+sx*sy*sz  cz*sx*sy-cy*sz  cx*sy
    //        cx*sz           cx*cz          -sx
    //       -cz*sy+cy*sx*sz  cy*cz*sx+sy*sz  cx*cy

    if ( MAT( 2, 1 ) < 1 ) 
	{
        if ( MAT( 2, 1 )  > -1 ) 
		{
            out->y = aTan2(MAT( 2, 0 ) , MAT( 2, 2 ) );
            out->x = (float) aSin( -MAT( 2, 1 ) );
            out->z = aTan2(MAT( 0, 1 ) , MAT( 1, 1 ) );
            return true;
        } 
		else 
		{
            // WARNING.  Not unique.  YA - ZA = atan2(r01,r00)
            out->y = aTan2(MAT( 1, 0 ) , MAT( 0, 0 ) );
            out->x = (float)D3DX_HALF_PI;
            out->z = 0.0;
            return false;
        }
    } 
	else 
	{
        // WARNING.  Not unique.  YA + ZA = atan2(-r01,r00)
        out->y = aTan2( -MAT( 1, 0 ) , MAT( 0, 0 ) );
        out->x = -(float)D3DX_HALF_PI;
        out->z = 0.0f;
        return false;
    }
}

#endif





