//ray.cpp
#include <assert.h>
#include <d3d9.h>
#include <d3dx9.h>
#include "ray.h"


Ray::Ray()
{
	m_dir = m_org = D3DXVECTOR3( 0.0f, 0.0f, 0.0f );
	m_length = 0.0f;
}
//------------------------------------------------------------------------------------------------
const D3DXVECTOR3&	Ray::GetOrg() const 
{ 
	return m_org; 
}
//------------------------------------------------------------------------------------------------
void Ray::SetOrg( const D3DXVECTOR3 &origin ) 
{ 
	m_org = origin; 
}
//------------------------------------------------------------------------------------------------
const D3DXVECTOR3&	Ray::GetDir() const 
{ 
	return m_dir; 
}
//------------------------------------------------------------------------------------------------
void Ray::SetDir( const D3DXVECTOR3 &dir ) 
{ 
	m_dir = dir; 
	D3DXVec3Normalize( &m_dir, &m_dir );
}
//------------------------------------------------------------------------------------------------
float Ray::GetLength() const 
{ 
	return m_length; 
}
//------------------------------------------------------------------------------------------------
void Ray::SetLength( float len ) 
{ 
	assert(len > 0.0f); 
	m_length = len; 
}
//------------------------------------------------------------------------------------------------